Index: /bdm/stat/libEF.h
===================================================================
--- /bdm/stat/libEF.h (revision 262)
+++ /bdm/stat/libEF.h (revision 270)
@@ -19,5 +19,5 @@
 //#include <std>
 
-namespace bdm{
+namespace bdm {
 
 
@@ -39,5 +39,5 @@
 //	eEF() :epdf() {};
 	//! default constructor
-	eEF ( const RV &rv ) :epdf ( rv ) {};
+	eEF ( ) :epdf ( ) {};
 	//! logarithm of the normalizing constant, \f$\mathcal{I}\f$
 	virtual double lognc() const =0;
@@ -47,5 +47,5 @@
 	virtual double evallog_nn ( const vec &val ) const{it_error ( "Not implemented" );return 0.0;};
 	//!Evaluate normalized log-probability
-	virtual double evallog ( const vec &val ) const {double tmp;tmp= evallog_nn ( val )-lognc();it_assert_debug(std::isfinite(tmp),"Infinite value"); return tmp;}
+	virtual double evallog ( const vec &val ) const {double tmp;tmp= evallog_nn ( val )-lognc();it_assert_debug ( std::isfinite ( tmp ),"Infinite value" ); return tmp;}
 	//!Evaluate normalized log-probability for many samples
 	virtual vec evallog ( const mat &Val ) const {
@@ -68,5 +68,5 @@
 public:
 	//! Default constructor
-	mEF ( const RV &rv0, const RV &rvc0 ) :mpdf ( rv0,rvc0 ) {};
+	mEF ( ) :mpdf ( ) {};
 };
 
@@ -79,6 +79,6 @@
 	double last_lognc;
 public:
-	//! Default constructor
-	BMEF ( const RV &rv, double frg0=1.0 ) :BM ( rv ), frg ( frg0 ) {}
+	//! Default constructor (=empty constructor)
+	BMEF ( double frg0=1.0 ) :BM ( ), frg ( frg0 ) {}
 	//! Copy constructor
 	BMEF ( const BMEF &B ) :BM ( B ), frg ( B.frg ), last_lognc ( B.last_lognc ) {}
@@ -112,41 +112,40 @@
 	//! Covariance matrix in decomposed form
 	sq_T R;
-	//! dimension (redundant from rv.count() for easier coding )
-	int dim;
-public:
-	//!Default constructor
-	enorm ( const RV &rv );
-	//! Set mean value \c mu and covariance \c R
+public:
+	//!\name Constructors
+	//!@{
+
+	enorm ( ):eEF ( ), mu ( ),R ( ) {};
+	enorm ( const vec &mu,const sq_T &R ) {set_parameters ( mu,R );}
 	void set_parameters ( const vec &mu,const sq_T &R );
-	////! tupdate in exponential form (not really handy)
-	//void tupdate ( double phi, mat &vbar, double nubar );
+	//!@}
+
+	//! \name Mathematical operations
+	//!@{
+
 	//! dupdate in exponential form (not really handy)
 	void dupdate ( mat &v,double nu=1.0 );
 
 	vec sample() const;
-	//! TODO is it used?
 	mat sample ( int N ) const;
-//	double eval ( const vec &val ) const ;
 	double evallog_nn ( const vec &val ) const;
 	double lognc () const;
 	vec mean() const {return mu;}
-	vec variance() const {return diag(R.to_mat());}
+	vec variance() const {return diag ( R.to_mat() );}
 //	mlnorm<sq_T>* condition ( const RV &rvn ) const ;
 	mpdf* condition ( const RV &rvn ) const ;
 //	enorm<sq_T>* marginal ( const RV &rv ) const;
 	epdf* marginal ( const RV &rv ) const;
-//Access methods
-	//! returns a pointer to the internal mean value. Use with Care!
+	//!@}
+
+	//! \name Access to attributes
+	//!@{
+
 	vec& _mu() {return mu;}
-
-	//! access function
 	void set_mu ( const vec mu0 ) { mu=mu0;}
-
-	//! returns pointers to the internal variance and its inverse. Use with Care!
 	sq_T& _R() {return R;}
 	const sq_T& _R() const {return R;}
-
-	//! access method
-//	mat getR () {return R.to_mat();}
+	//!@}
+
 };
 
@@ -164,29 +163,28 @@
 	double nu;
 	//! Dimension of the output
-	int xdim;
+	int dimx;
 	//! Dimension of the regressor
 	int nPsi;
 public:
-	//!Default constructor, if nu0<0 a minimal nu0 will be computed
-	egiw ( RV rv, mat V0, double nu0=-1.0 ) : eEF ( rv ), V ( V0 ), nu ( nu0 ) {
-		xdim = rv.count() /V.rows();
-		it_assert_debug ( rv.count() ==xdim*V.rows(),"Incompatible V0." );
-		nPsi = V.rows()-xdim;
-		//set mu to have proper normalization and 
-		if (nu0<0){
-			nu = 0.1 +nPsi +2*xdim +2; // +2 assures finite expected value of R
+	//!\name Constructors
+	//!@{
+	egiw() :eEF() {};
+	egiw ( int dimx0, ldmat V0, double nu0=-1.0 ) :eEF() {set_parameters ( dimx0,V0, nu0 );};
+
+	void set_parameters ( int dimx0, ldmat V0, double nu0=-1.0 ) {
+		dimx=dimx0;
+		nPsi = V0.rows()-dimx;
+		dim = dimx* ( dimx+nPsi ); // size(R) + size(Theta)
+
+		V=V0;
+		if ( nu0<0 ) {
+			nu = 0.1 +nPsi +2*dimx +2; // +2 assures finite expected value of R
 			// terms before that are sufficient for finite normalization
 		}
-	}
-	//!Full constructor for V in ldmat form
-	egiw ( RV rv, ldmat V0, double nu0=-1.0 ) : eEF ( rv ), V ( V0 ), nu ( nu0 ) {
-		xdim = rv.count() /V.rows();
-		it_assert_debug ( rv.count() ==xdim*V.rows(),"Incompatible V0." );
-		nPsi = V.rows()-xdim;
-		if (nu0<0){
-			nu = 0.1 +nPsi +2*xdim +2; // +2 assures finite expected value of R
-			// terms before that are sufficient for finite normalization
+		else {
+			nu=nu0;
 		}
 	}
+	//!@}
 
 	vec sample() const;
@@ -197,14 +195,14 @@
 	double evallog_nn ( const vec &val ) const;
 	double lognc () const;
-
-	//Access
-	//! returns a pointer to the internal statistics. Use with Care!
+	void pow ( double p ) {V*=p;nu*=p;};
+
+	//! \name Access attributes
+	//!@{
+
 	ldmat& _V() {return V;}
-	//! returns a pointer to the internal statistics. Use with Care!
 	const ldmat& _V() const {return V;}
-	//! returns a pointer to the internal statistics. Use with Care!
 	double& _nu()  {return nu;}
 	const double& _nu() const {return nu;}
-	void pow ( double p ) {V*=p;nu*=p;};
+	//!@}
 };
 
@@ -224,14 +222,25 @@
 	double gamma;
 public:
-	//!Default constructor
-	eDirich ( const RV &rv, const vec &beta0 ) : eEF ( rv ),beta ( beta0 ) {it_assert_debug ( rv.count() ==beta.length(),"Incompatible statistics" ); };
-	//! Copy constructor
-	eDirich ( const eDirich &D0 ) : eEF ( D0.rv ),beta ( D0.beta ) {};
+	//!\name Constructors
+	//!@{
+
+	eDirich () : eEF ( ) {};
+	eDirich ( const eDirich &D0 ) : eEF () {set_parameters ( D0.beta );};
+	eDirich ( const vec &beta0 ) {set_parameters ( beta0 );};
+	void set_parameters ( const vec &beta0 ) {
+		beta= beta0;
+		dim = beta.length();
+		gamma = sum ( beta );
+	}
+	//!@}
+
 	vec sample() const {it_error ( "Not implemented" );return vec_1 ( 0.0 );};
 	vec mean() const {return beta/gamma;};
-	vec variance() const {return elem_mult(beta,(beta+1))/ (gamma*(gamma+1));}
+	vec variance() const {return elem_mult ( beta, ( beta+1 ) ) / ( gamma* ( gamma+1 ) );}
 	//! In this instance, val is ...
-	double evallog_nn ( const vec &val ) const {double tmp; tmp=( beta-1 ) *log ( val );		it_assert_debug(std::isfinite(tmp),"Infinite value");
-	return tmp;};
+	double evallog_nn ( const vec &val ) const {
+		double tmp; tmp= ( beta-1 ) *log ( val );		it_assert_debug ( std::isfinite ( tmp ),"Infinite value" );
+		return tmp;
+	};
 	double lognc () const {
 		double tmp;
@@ -240,5 +249,5 @@
 		for ( int i=0;i<beta.length();i++ ) {lgb+=lgamma ( beta ( i ) );}
 		tmp= lgb-lgamma ( gam );
-		it_assert_debug(std::isfinite(tmp),"Infinite value");
+		it_assert_debug ( std::isfinite ( tmp ),"Infinite value" );
 		return tmp;
 	};
@@ -246,12 +255,4 @@
 	vec& _beta()  {return beta;}
 	//!Set internal parameters
-	void set_parameters ( const vec &beta0 ) {
-		if ( beta0.length() !=beta.length() ) {
-			it_assert_debug ( rv.length() ==1,"Undefined" );
-			rv.set_size ( 0,beta0.length() );
-		}
-		beta= beta0;
-		gamma = sum(beta);
-	}
 };
 
@@ -265,7 +266,7 @@
 public:
 	//!Default constructor
-	multiBM ( const RV &rv, const vec beta0 ) : BMEF ( rv ),est ( rv,beta0 ),beta ( est._beta() ) {if(beta.length()>0){last_lognc=est.lognc();}else{last_lognc=0.0;}}
+	multiBM ( ) : BMEF ( ),est ( ),beta ( est._beta() ) {if ( beta.length() >0 ) {last_lognc=est.lognc();}else{last_lognc=0.0;}}
 	//!Copy constructor
-	multiBM ( const multiBM &B ) : BMEF ( B ),est ( rv,B.beta ),beta ( est._beta() ) {}
+	multiBM ( const multiBM &B ) : BMEF ( B ),est ( B.est ),beta ( est._beta() ) {}
 	//! Sets sufficient statistics to match that of givefrom mB0
 	void set_statistics ( const BM* mB0 ) {const multiBM* mB=dynamic_cast<const multiBM*> ( mB0 ); beta=mB->beta;}
@@ -300,5 +301,4 @@
 	void set_parameters ( const vec &beta0 ) {
 		est.set_parameters ( beta0 );
-		rv = est._rv();
 		if ( evalll ) {last_lognc=est.lognc();}
 	}
@@ -321,8 +321,11 @@
 	vec beta;
 public :
-	//! Default constructor
-	egamma ( const RV &rv ) :eEF ( rv ), alpha(rv.count()), beta(rv.count()) {};
-	//! Sets parameters
-	void set_parameters ( const vec &a, const vec &b ) {alpha=a,beta=b;};
+	//! \name Constructors
+	//!@{
+	egamma ( ) :eEF ( ), alpha(), beta() {};
+	egamma ( const vec &a, const vec &b ) {set_parameters ( a, b );};
+	void set_parameters ( const vec &a, const vec &b ) {alpha=a,beta=b;dim = alpha.length();};
+	//!@}
+
 	vec sample() const;
 	//! TODO: is it used anywhere?
@@ -331,7 +334,8 @@
 	double lognc () const;
 	//! Returns poiter to alpha and beta. Potentially dengerous: use with care!
-	void _param ( vec* &a, vec* &b ) {a=&alpha;b=&beta;};
-	vec mean() const {return elem_div(alpha,beta);}
-	vec variance() const {return elem_div(alpha,elem_mult(beta,beta)); }
+	vec& _alpha() {return alpha;}
+	vec& _beta() {return beta;}
+	vec mean() const {return elem_div ( alpha,beta );}
+	vec variance() const {return elem_div ( alpha,elem_mult ( beta,beta ) ); }
 };
 
@@ -351,25 +355,29 @@
 
 class eigamma : public eEF {
-	protected:
+protected:
+	//!internal egamma
+	egamma eg;
 	//! Vector \f$\alpha\f$
-		vec* alpha;
+	vec &alpha;
 	//! Vector \f$\beta\f$ (in fact it is 1/beta as used in definition of iG)
-		vec* beta;
-		//!internal egamma
-		egamma eg;
-	public :
-	//! Default constructor
-		eigamma ( const RV &rv ) :eEF ( rv ), eg(rv) {eg._param(alpha,beta);};
-	//! Sets parameters
-		void set_parameters ( const vec &a, const vec &b ) {*alpha=a,*beta=b;};
-		vec sample() const {return 1.0/eg.sample();};
+	vec &beta;
+public :
+	//! \name Constructors
+	//!@{
+	eigamma ( ) :eEF ( ), eg(),alpha ( eg._alpha() ), beta ( eg._beta() ) {};
+	eigamma ( const vec &a, const vec &b ):eEF ( ), eg(),alpha ( eg._alpha() ), beta ( eg._beta() ) {eg.set_parameters ( a,b );};
+	void set_parameters ( const vec &a, const vec &b ) {eg.set_parameters ( a,b );};
+	//!@}
+
+	vec sample() const {return 1.0/eg.sample();};
 	//! TODO: is it used anywhere?
 //	mat sample ( int N ) const;
-		double evallog ( const vec &val ) const {return eg.evallog(val);};
-		double lognc () const {return eg.lognc();};
+	double evallog ( const vec &val ) const {return eg.evallog ( val );};
+	double lognc () const {return eg.lognc();};
 	//! Returns poiter to alpha and beta. Potentially dangerous: use with care!
-		void _param ( vec* &a, vec* &b ) {a=alpha;b=beta;};
-		vec mean() const {return elem_div(*beta,*alpha-1);}
-		vec variance() const {vec mea=mean(); return elem_div(elem_mult(mea,mea),*alpha-2);}
+	vec mean() const {return elem_div ( beta,alpha-1 );}
+	vec variance() const {vec mea=mean(); return elem_div ( elem_mult ( mea,mea ),alpha-2 );}
+	vec& _alpha() {return alpha;}
+	vec& _beta() {return beta;}
 };
 /*
@@ -404,15 +412,8 @@
 	double lnk;
 public:
-	//! Defualt constructor
-	euni ( const RV rv ) :epdf ( rv ) {}
-	double eval ( const vec &val ) const  {return nk;}
-	double evallog ( const vec &val ) const  {return lnk;}
-	vec sample() const {
-		vec smp ( rv.count() );
-#pragma omp critical
-		UniRNG.sample_vector ( rv.count(),smp );
-		return low+elem_mult ( distance,smp );
-	}
-	//! set values of \c low and \c high
+	//! \name Constructors
+	//!@{
+	euni ( ) :epdf ( ) {}
+	euni ( const vec &low0, const vec &high0 ) {set_parameters ( low0,high0 );}
 	void set_parameters ( const vec &low0, const vec &high0 ) {
 		distance = high0-low0;
@@ -422,7 +423,19 @@
 		nk = prod ( 1.0/distance );
 		lnk = log ( nk );
-	}
-	vec mean() const {return (high-low)/2.0;}
-	vec variance() const {return (pow(high,2)+pow(low,2)+elem_mult(high,low))/3.0;}
+		dim = low.length();
+	}
+	//!@}
+
+	double eval ( const vec &val ) const  {return nk;}
+	double evallog ( const vec &val ) const  {return lnk;}
+	vec sample() const {
+		vec smp ( dim );
+#pragma omp critical
+		UniRNG.sample_vector ( dim ,smp );
+		return low+elem_mult ( distance,smp );
+	}
+	//! set values of \c low and \c high
+	vec mean() const {return ( high-low ) /2.0;}
+	vec variance() const {return ( pow ( high,2 ) +pow ( low,2 ) +elem_mult ( high,low ) ) /3.0;}
 };
 
@@ -442,12 +455,13 @@
 	vec& _mu; //cached epdf.mu;
 public:
-	//! Constructor
-	mlnorm ( const RV &rv, const RV &rvc );
+	//! \name Constructors
+	//!@{
+	mlnorm ( ) :mEF (),epdf ( ),A ( ),_mu ( epdf._mu() ) {ep =&epdf; };
+	mlnorm ( const  mat &A, const vec &mu0, const sq_T &R ) :epdf ( ),_mu ( epdf._mu() ) {
+		ep =&epdf; set_parameters ( A,mu0,R );
+	};
 	//! Set \c A and \c R
 	void set_parameters ( const  mat &A, const vec &mu0, const sq_T &R );
-//	//!Generate one sample of the posterior
-//	vec samplecond (const vec &cond, double &lik );
-//	//!Generate matrix of samples of the posterior
-//	mat samplecond (const vec &cond, vec &lik, int n );
+	//!@}
 	//! Set value of \c rvc . Result of this operation is stored in \c epdf use function \c _ep to access it.
 	void condition ( const vec &cond );
@@ -466,8 +480,8 @@
 /*! (Approximate) Student t density with linear function of mean value
 
-The internal epdf of this class is of the type of a Gaussian (enorm). 
+The internal epdf of this class is of the type of a Gaussian (enorm).
 However, each conditioning is trying to assure the best possible approximation by taking into account the zeta function. See [] for reference.
 
-Perhaps a moment-matching technique? 
+Perhaps a moment-matching technique?
 */
 class mlstudent : public mlnorm<ldmat> {
@@ -477,9 +491,11 @@
 	ldmat Re;
 public:
-	mlstudent ( const RV &rv0, const RV &rvc0 ) :mlnorm<ldmat> ( rv0,rvc0 ),
-			Lambda ( rv0.count() ),
-			_R ( epdf._R() ) {}
-	void set_parameters ( const mat &A0, const vec &mu0, const ldmat &R0, const ldmat& Lambda0) {
-		epdf.set_parameters ( zeros ( rv.count() ),Lambda );
+	mlstudent ( ) :mlnorm<ldmat> (),
+			Lambda (),	_R ( epdf._R() ) {}
+	void set_parameters ( const mat &A0, const vec &mu0, const ldmat &R0, const ldmat& Lambda0 ) {
+		it_assert_debug ( A0.rows() ==mu0.length(),"" );
+		it_assert_debug ( R0.rows() ==A0.rows(),"" );
+
+		epdf.set_parameters ( mu0,Lambda ); //
 		A = A0;
 		mu_const = mu0;
@@ -491,11 +507,12 @@
 		double zeta;
 		//ugly hack!
-		if ((cond.length()+1)==Lambda.rows()){
-			zeta = Lambda.invqform ( concat(cond, vec_1(1.0)) );
-		} else {
+		if ( ( cond.length() +1 ) ==Lambda.rows() ) {
+			zeta = Lambda.invqform ( concat ( cond, vec_1 ( 1.0 ) ) );
+		}
+		else {
 			zeta = Lambda.invqform ( cond );
 		}
 		_R = Re;
-		_R*=( 1+zeta );// / ( nu ); << nu is in Re!!!!!!
+		_R*= ( 1+zeta );// / ( nu ); << nu is in Re!!!!!!
 	};
 
@@ -517,12 +534,12 @@
 	double k;
 	//! cache of epdf.beta
-	vec* _beta;
+	vec &_beta;
 
 public:
 	//! Constructor
-	mgamma ( const RV &rv,const RV &rvc ): mEF ( rv,rvc ), epdf ( rv ) {vec* tmp; epdf._param ( tmp,_beta );ep=&epdf;};
+	mgamma ( ) : mEF ( ), epdf (), _beta ( epdf._beta() ) {ep=&epdf;};
 	//! Set value of \c k
-	void set_parameters ( double k );
-	void condition ( const vec &val ) {*_beta=k/val;};
+	void set_parameters ( double k, const vec &beta0 );
+	void condition ( const vec &val ) {_beta=k/val;};
 };
 
@@ -530,29 +547,37 @@
 \brief  Inverse-Gamma random walk
 
-Mean value, \f$\mu\f$, of this density is given by \c rvc .
-Standard deviation of the random walk is proportional to one \f$k\f$-th the mean.
-This is achieved by setting \f$\alpha=\mu/k+2\f$ and \f$\beta=\mu(\alpha-1)\f$.
-
-The standard deviation of the walk is then: \f$\mu/\sqrt(k)\f$.
+Mean value, \f$ \mu \f$, of this density is given by \c rvc .
+Standard deviation of the random walk is proportional to one \f$ k \f$-th the mean.
+This is achieved by setting \f$ \alpha=\mu/k^2+2 \f$ and \f$ \beta=\mu(\alpha-1)\f$.
+
+The standard deviation of the walk is then: \f$ \mu/\sqrt(k)\f$.
  */
 class migamma : public mEF {
-	protected:
+protected:
 	//! Internal epdf that arise by conditioning on \c rvc
-		eigamma epdf;
+	eigamma epdf;
 	//! Constant \f$k\f$
-		double k;
+	double k;
+	//! cache of epdf.alpha
+	vec &_alpha;
 	//! cache of epdf.beta
-		vec* _beta;
-		//! chaceh of epdf.alpha
-		vec* _alpha;
-
-	public:
-	//! Constructor
-		migamma ( const RV &rv,const RV &rvc ): mEF ( rv,rvc ), epdf ( rv ) {epdf._param ( _alpha,_beta );ep=&epdf;};
+	vec &_beta;
+
+public:
+	//! \name Constructors
+	//!@{
+	migamma ( ) : mEF (), epdf ( ), _alpha ( epdf._alpha() ), _beta ( epdf._beta() ) {ep=&epdf;};
+	migamma ( const migamma &m ) : mEF (), epdf ( m.epdf ), _alpha ( epdf._alpha() ), _beta ( epdf._beta() ) {ep=&epdf;};
+	//!@}
+
 	//! Set value of \c k
-		void set_parameters ( double k0 ){k=k0;*_alpha=1.0/(k*k)+2;};
-		void condition ( const vec &val ) {
-			*_beta=elem_mult(val,(*_alpha-1));
-		};
+	void set_parameters ( int len, double k0 ) {
+		k=k0;
+		epdf.set_parameters ( ( 1.0/ ( k*k ) +2.0 ) *ones ( len ) /*alpha*/, ones ( len ) /*beta*/ );
+		dimc = dimension();
+	};
+	void condition ( const vec &val ) {
+		_beta=elem_mult ( val, ( _alpha-1.0 ) );
+	};
 };
 
@@ -576,12 +601,13 @@
 public:
 	//! Constructor
-	mgamma_fix ( const RV &rv,const RV &rvc ) : mgamma ( rv,rvc ),refl ( rv.count() ) {};
+	mgamma_fix ( ) : mgamma ( ),refl () {};
 	//! Set value of \c k
 	void set_parameters ( double k0 , vec ref0, double l0 ) {
-		mgamma::set_parameters ( k0 );
+		mgamma::set_parameters ( k0, ref0 );
 		refl=pow ( ref0,1.0-l0 );l=l0;
+		dimc=dimension();
 	};
 
-	void condition ( const vec &val ) {vec mean=elem_mult ( refl,pow ( val,l ) ); *_beta=k/mean;};
+	void condition ( const vec &val ) {vec mean=elem_mult ( refl,pow ( val,l ) ); _beta=k/mean;};
 };
 
@@ -600,19 +626,24 @@
  */
 class migamma_fix : public migamma {
-	protected:
+protected:
 	//! parameter l
-		double l;
+	double l;
 	//! reference vector
-		vec refl;
-	public:
+	vec refl;
+public:
 	//! Constructor
-		migamma_fix ( const RV &rv,const RV &rvc ) : migamma ( rv,rvc ),refl ( rv.count() ) {};
+	migamma_fix ( ) : migamma (),refl ( ) {};
 	//! Set value of \c k
-		void set_parameters ( double k0 , vec ref0, double l0 ) {
-			migamma::set_parameters ( k0 );
-			refl=pow ( ref0,1.0-l0 );l=l0;
-		};
-
-		void condition ( const vec &val ) {vec mean=elem_mult ( refl,pow ( val,l ) ); migamma::condition(mean);};
+	void set_parameters ( double k0 , vec ref0, double l0 ) {
+		migamma::set_parameters ( ref0.length(), k0 );
+		refl=pow ( ref0,1.0-l0 );
+		l=l0;
+		dimc = dimension();
+	};
+
+	void condition ( const vec &val ) {
+		vec mean=elem_mult ( refl,pow ( val,l ) );
+		migamma::condition ( mean );
+	};
 };
 //! Switch between various resampling methods.
@@ -632,6 +663,10 @@
 	Array<vec> samples;
 public:
-	//! Default constructor
-	eEmp ( const RV &rv0 ,int n0 ) :epdf ( rv0 ),n ( n0 ),w ( n ),samples ( n ) {};
+	//! \name Constructors 
+	//!@{
+	eEmp ( ) :epdf ( ),w (  ),samples ( ) {};
+	eEmp (const eEmp &e ): epdf(e), w(e.w), samples(e.samples) {};
+	//!@}
+	
 	//! Set samples and weights
 	void set_parameters ( const vec &w0, const epdf* pdf0 );
@@ -639,5 +674,5 @@
 	void set_samples ( const epdf* pdf0 );
 	//! Set sample
-	void set_n ( int n0, bool copy=true ){w.set_size(n0,copy);samples.set_size(n0,copy);};
+	void set_n ( int n0, bool copy=true ) {w.set_size ( n0,copy );samples.set_size ( n0,copy );};
 	//! Potentially dangerous, use with care.
 	vec& _w()  {return w;};
@@ -655,12 +690,12 @@
 	double evallog ( const vec &val ) const {it_error ( "Not implemented" );return 0.0;}
 	vec mean() const {
-		vec pom=zeros ( rv.count() );
+		vec pom=zeros ( dim );
 		for ( int i=0;i<n;i++ ) {pom+=samples ( i ) *w ( i );}
 		return pom;
 	}
 	vec variance() const {
-		vec pom=zeros ( rv.count() );
-		for ( int i=0;i<n;i++ ) {pom+=pow(samples ( i ),2) *w ( i );}
-		return pom-pow(mean(),2);
+		vec pom=zeros ( dim );
+		for ( int i=0;i<n;i++ ) {pom+=pow ( samples ( i ),2 ) *w ( i );}
+		return pom-pow ( mean(),2 );
 	}
 };
@@ -668,7 +703,4 @@
 
 ////////////////////////
-
-template<class sq_T>
-enorm<sq_T>::enorm ( const RV &rv ) :eEF ( rv ), mu ( rv.count() ),R ( rv.count() ),dim ( rv.count() ) {};
 
 template<class sq_T>
@@ -677,4 +709,5 @@
 	mu = mu0;
 	R = R0;
+	dim = mu0.length();
 };
 
@@ -692,5 +725,5 @@
 vec enorm<sq_T>::sample() const {
 	vec x ( dim );
-	#pragma omp critical 
+#pragma omp critical
 	NorRNG.sample_vector ( dim,x );
 	vec smp = R.sqrt_mult ( x );
@@ -708,5 +741,5 @@
 
 	for ( i=0;i<N;i++ ) {
-	#pragma omp critical 
+#pragma omp critical
 		NorRNG.sample_vector ( dim,x );
 		pom = R.sqrt_mult ( x );
@@ -741,13 +774,12 @@
 
 template<class sq_T>
-mlnorm<sq_T>::mlnorm ( const RV &rv0, const RV &rvc0 ) :mEF ( rv0,rvc0 ),epdf ( rv0 ),A ( rv0.count(),rv0.count() ),_mu ( epdf._mu() ) {
-	ep =&epdf;
-}
-
-template<class sq_T>
 void mlnorm<sq_T>::set_parameters ( const mat &A0, const vec &mu0, const sq_T &R0 ) {
-	epdf.set_parameters ( zeros ( rv.count() ),R0 );
+	it_assert_debug ( A0.rows() ==mu0.length(),"" );
+	it_assert_debug ( A0.rows() ==R0.rows(),"" );
+
+	epdf.set_parameters ( zeros ( A0.rows() ),R0 );
 	A = A0;
 	mu_const = mu0;
+	dimc=A0.cols();
 }
 
@@ -785,8 +817,11 @@
 template<class sq_T>
 epdf* enorm<sq_T>::marginal ( const RV &rvn ) const {
+	it_assert_debug(isnamed(), "rv description is not assigned");
 	ivec irvn = rvn.dataind ( rv );
 
-	sq_T Rn ( R,irvn );
-	enorm<sq_T>* tmp = new enorm<sq_T> ( rvn );
+	sq_T Rn ( R,irvn ); //select rows and columns of R
+	
+	enorm<sq_T>* tmp = new enorm<sq_T>;
+	tmp->set_rv ( rvn );
 	tmp->set_parameters ( mu ( irvn ), Rn );
 	return tmp;
@@ -796,6 +831,8 @@
 mpdf* enorm<sq_T>::condition ( const RV &rvn ) const {
 
+	it_assert_debug ( isnamed(),"rvs are not assigned" );
+
 	RV rvc = rv.subt ( rvn );
-	it_assert_debug ( ( rvc.count() +rvn.count() ==rv.count() ),"wrong rvn" );
+	it_assert_debug ( ( rvc._dsize() +rvn._dsize() ==rv._dsize() ),"wrong rvn" );
 	//Permutation vector of the new R
 	ivec irvn = rvn.dataind ( rv );
@@ -807,9 +844,9 @@
 	mat S=Rn.to_mat();
 	//fixme
-	int n=rvn.count()-1;
+	int n=rvn._dsize()-1;
 	int end=R.rows()-1;
 	mat S11 = S.get ( 0,n, 0, n );
-	mat S12 = S.get ( 0, n , rvn.count(), end );
-	mat S22 = S.get ( rvn.count(), end, rvn.count(), end );
+	mat S12 = S.get ( 0, n , rvn._dsize(), end );
+	mat S22 = S.get ( rvn._dsize(), end, rvn._dsize(), end );
 
 	vec mu1 = mu ( irvn );
@@ -818,6 +855,6 @@
 	sq_T R_n ( S11 - A *S12.T() );
 
-	mlnorm<sq_T>* tmp=new mlnorm<sq_T> ( rvn,rvc );
-
+	mlnorm<sq_T>* tmp=new mlnorm<sq_T> ( );
+	tmp->set_rv(rvn); tmp->set_rvc(rvc);
 	tmp->set_parameters ( A,mu1-A*mu2,R_n );
 	return tmp;
Index: /bdm/stat/emix.h
===================================================================
--- /bdm/stat/emix.h (revision 254)
+++ /bdm/stat/emix.h (revision 270)
@@ -47,5 +47,7 @@
 	//!Default constructor. By default, the given epdf is not copied!
 	//! It is assumed that this function will be used only temporarily.
-	mratio ( const epdf* nom0, const RV &rv, bool copy=false ) :mpdf ( rv,nom0->_rv().subt ( rv ) ), dl ( rv,rvc,nom0->_rv() ) {
+	mratio ( const epdf* nom0, const RV &rv, bool copy=false ) :mpdf ( ), dl ( rv,rvc,nom0->_rv() ) {
+		ep->set_rv(_rv());
+		set_rvc(nom0->_rv().subt ( rv ) );
 		if ( copy ) {
 //			nom = nom0->_copy_();
@@ -62,6 +64,6 @@
 	double evallogcond ( const vec &val, const vec &cond ) {
 		double tmp;
-		vec nom_val ( rv.count() +rvc.count() );
-		dl.fill_val_cond ( nom_val,val,cond );
+		vec nom_val ( ep->dimension() + dimc );
+		dl.pushup_cond ( nom_val,val,cond );
 		tmp = exp ( nom->evallog ( nom_val ) - den->evallog ( cond ) );
 		it_assert_debug(std::isfinite(tmp),"Infinite value");
@@ -94,12 +96,12 @@
 public:
 	//!Default constructor
-	emix ( const RV &rv ) : epdf ( rv ) {};
+	emix (  ) : epdf ( ) {};
 	//! Set weights \c w and components \c Coms
 	//!By default Coms are copied inside. Parameter \c copy can be set to false if Coms live externally. Use method ownComs() if Coms should be destroyed by the destructor.
-	void set_parameters ( const vec &w, const Array<epdf*> &Coms, bool copy=true );
+	void set_parameters ( const vec &w, const Array<epdf*> &Coms, bool copy=false );
 
 	vec sample() const;
 	vec mean() const {
-		int i; vec mu = zeros ( rv.count() );
+		int i; vec mu = zeros ( dim);
 		for ( i = 0;i < w.length();i++ ) {mu += w ( i ) * Coms ( i )->mean(); }
 		return mu;
@@ -107,5 +109,5 @@
 	vec variance() const {
 		//non-central moment
-		vec mom2 = zeros(rv.count());
+		vec mom2 = zeros(dim);
 		for ( int i = 0;i < w.length();i++ ) {mom2 += w ( i ) * pow(Coms ( i )->mean(),2); }
 		//central moment
@@ -165,12 +167,17 @@
 	//! Data link for each mpdfs
 	Array<datalink_m2m*> dls;
+	//! dummy ep
+	epdf dummy;
 public:
 	/*!\brief Constructor from list of mFacs,
 	*/
-	mprod ( Array<mpdf*> mFacs ) : compositepdf ( mFacs ), mpdf ( getrv ( true ),RV() ), epdfs ( n ), dls ( n ) {
-		setrvc ( rv,rvc );
+	mprod ( Array<mpdf*> mFacs ) : compositepdf ( mFacs ), mpdf (), epdfs ( n ), dls ( n ) {
+		ep=&dummy;
+		RV rv=getrv(true);
+		set_rv(rv);dummy.set_parameters(rv._dsize());
+		setrvc ( ep->_rv(),rvc );
 		// rv and rvc established = > we can link them with mpdfs
 		for ( int i = 0;i < n;i++ ) {
-			dls ( i ) = new datalink_m2m ( mpdfs ( i )->_rv(), mpdfs ( i )->_rvc(), rv, rvc );
+			dls ( i ) = new datalink_m2m ( mpdfs ( i )->_rv(), mpdfs ( i )->_rvc(), _rv(), _rvc() );
 		}
 
@@ -182,5 +189,5 @@
 	double evallogcond ( const vec &val, const vec &cond ) {
 		int i;
-		double res = 1.0;
+		double res = 0.0;
 		for ( i = n - 1;i >= 0;i-- ) {
 			/*			if ( mpdfs(i)->_rvc().count() >0) {
@@ -188,7 +195,7 @@
 						}
 						// add logarithms
-						res += epdfs ( i )->evallog ( dls ( i )->get_val ( val ) );*/
-			res *= mpdfs ( i )->evallogcond (
-			           dls ( i )->get_val ( val ),
+						res += epdfs ( i )->evallog ( dls ( i )->pushdown ( val ) );*/
+			res += mpdfs ( i )->evallogcond (
+			           dls ( i )->pushdown ( val ),
 			           dls ( i )->get_cond ( val, cond )
 			       );
@@ -196,25 +203,24 @@
 		return res;
 	}
-	vec samplecond ( const vec &cond, double &ll ) {
+	//TODO smarter...
+	vec samplecond ( const vec &cond ) {
 		//! Ugly hack to help to discover if mpfs are not in proper order. Correct solution = check that explicitely.
-		vec smp= std::numeric_limits<double>::infinity() * ones ( rv.count() );
+		vec smp= std::numeric_limits<double>::infinity() * ones ( ep->dimension() );
 		vec smpi;
-		ll = 0;
 		// Hard assumption here!!! We are going backwards, to assure that samples that are needed from smp are already generated!
 		for ( int i = ( n - 1 );i >= 0;i-- ) {
-			if ( mpdfs ( i )->_rvc().count() ) {
+			if ( mpdfs ( i )->dimensionc() ) {
 				mpdfs ( i )->condition ( dls ( i )->get_cond ( smp ,cond ) ); // smp is val here!!
 			}
 			smpi = epdfs ( i )->sample();
 			// copy contribution of this pdf into smp
-			dls ( i )->fill_val ( smp, smpi );
+			dls ( i )->pushup ( smp, smpi );
 			// add ith likelihood contribution
-			ll+=epdfs ( i )->evallog ( smpi );
 		}
 		return smp;
 	}
-	mat samplecond ( const vec &cond, vec &ll, int N ) {
-		mat Smp ( rv.count(),N );
-		for ( int i=0;i<N;i++ ) {Smp.set_col ( i,samplecond ( cond,ll ( i ) ) );}
+	mat samplecond ( const vec &cond,  int N ) {
+		mat Smp ( dimension(),N );
+		for ( int i=0;i<N;i++ ) {Smp.set_col ( i,samplecond ( cond ) );}
 		return Smp;
 	}
@@ -229,7 +235,7 @@
 	Array<const epdf*> epdfs;
 	//! Array of indeces
-	Array<datalink_e2e*> dls;
-public:
-	eprod ( const Array<const epdf*> epdfs0 ) : epdf ( RV() ),epdfs ( epdfs0 ),dls ( epdfs.length() ) {
+	Array<datalink*> dls;
+public:
+	eprod ( const Array<const epdf*> epdfs0 ) : epdf (  ),epdfs ( epdfs0 ),dls ( epdfs.length() ) {
 		bool independent=true;
 		for ( int i=0;i<epdfs.length();i++ ) {
@@ -238,29 +244,29 @@
 		}
 		for ( int i=0;i<epdfs.length();i++ ) {
-			dls ( i ) = new datalink_e2e ( epdfs ( i )->_rv() , rv );
+			dls ( i ) = new datalink ( epdfs ( i )->_rv() , rv );
 		}
 	}
 
 	vec mean() const {
-		vec tmp ( rv.count() );
+		vec tmp ( dim );
 		for ( int i=0;i<epdfs.length();i++ ) {
 			vec pom = epdfs ( i )->mean();
-			dls ( i )->fill_val ( tmp, pom );
+			dls ( i )->pushup ( tmp, pom );
 		}
 		return tmp;
 	}
 	vec variance() const {
-		vec tmp ( rv.count() ); //second moment
+		vec tmp ( dim ); //second moment
 		for ( int i=0;i<epdfs.length();i++ ) {
 			vec pom = epdfs ( i )->mean();
-			dls ( i )->fill_val ( tmp, pow(pom,2) );
+			dls ( i )->pushup ( tmp, pow(pom,2) );
 		}
 		return tmp-pow(mean(),2);
 	}
 	vec sample() const {
-		vec tmp ( rv.count() );
+		vec tmp ( dim );
 		for ( int i=0;i<epdfs.length();i++ ) {
 			vec pom = epdfs ( i )->sample();
-			dls ( i )->fill_val ( tmp, pom );
+			dls ( i )->pushup ( tmp, pom );
 		}
 		return tmp;
@@ -269,5 +275,5 @@
 		double tmp=0;
 		for ( int i=0;i<epdfs.length();i++ ) {
-			tmp+=epdfs ( i )->evallog ( dls ( i )->get_val ( val ) );
+			tmp+=epdfs ( i )->evallog ( dls ( i )->pushdown ( val ) );
 		}
 		it_assert_debug(std::isfinite(tmp),"Infinite");
@@ -293,5 +299,5 @@
 public:
 	//!Default constructor
-	mmix ( RV &rv, RV &rvc ) : mpdf ( rv, rvc ), Epdf ( rv ) {ep = &Epdf;};
+	mmix ( ) : mpdf ( ), Epdf () {ep = &Epdf;};
 	//! Set weights \c w and components \c R
 	void set_parameters ( const vec &w, const Array<mpdf*> &Coms ) {
Index: /bdm/stat/loggers.h
===================================================================
--- /bdm/stat/loggers.h (revision 263)
+++ /bdm/stat/loggers.h (revision 270)
@@ -42,5 +42,5 @@
 		int i; int n =entries.length();
 		vectors.set_size ( n ); 
-		for ( i=0;i<n;i++ ) {vectors(i).set_size (maxlen,entries(i).count() );}
+		for ( i=0;i<n;i++ ) {vectors(i).set_size (maxlen,entries(i)._dsize() );}
 		;
 	}
